import ball
import pygame
from pygame.locals import *
from sys import exit
from vector import *
from ball import *

width, height = 640, 480
radius = 10 # ball's radius

pygame.init()
screen = pygame.display.set_mode((width, height), 0, 32)
pygame.display.set_caption("Animate X!")

###create ball###
x = width/2 - radius
y = height/2 - radius
heading = Vector.vector_from_points((0,0), (0,0))
ball = Ball((100,200,100), (x,y), radius, heading, 0)

clock = pygame.time.Clock()


while True:
    for event in pygame.event.get():
        if event.type == QUIT:
            exit()

        #user input: change direction and speed of ball
        if event.type == MOUSEBUTTONDOWN:
                x2, y2 = event.pos #mouse position

                #calculate vector from current point to mouse position
                ball.heading = Vector.vector_from_points((ball.x,ball.y), (x2 - ball.radius ,y2 - ball.radius))
        
                #speed is calculated as the magnitude of the vector, can also be modified otherwise
                ball.speed = ball.heading.get_magnitude()

                #normalize direction-vector for calculation of movement
                ball.heading.normalize()


    time_passed = clock.tick() / 1000.0 #time passed since last call
    moved_distance = time_passed * ball.speed #calculate distance the ball has passed
    
    #calculate new ball position
    ball.x = ball.x+ ball.heading.x * moved_distance
    ball.y = ball.y + ball.heading.y * moved_distance

    #check for collision with walls
    if (ball.x + 2*ball.radius) >= width:# or ball.x < 0: #left and right edge
        ball.x = width - 2*ball.radius #push back to edge
        ball.heading.x = ball.heading.x * -1
        ball.speed *= 0.85 #slow down
    if ball.x <= 0: #left edge
        ball.x = 0 #push back to edge
        ball.heading.x = ball.heading.x * -1
        ball.speed *= 0.85 #slow down

    if (ball.y + 2*ball.radius) >= height:  #upper and lower edge
        ball.y = height - 2*ball.radius
        ball.heading.y = ball.heading.y * -1
        ball.speed *= 0.85 #slow down

    if ball.y <= 0:  #upper and lower edge
        ball.y = 0
        ball.heading.y = ball.heading.y * -1
        ball.speed *= 0.85 #slow down
        
    # not the best way, because we move the ball even if it hits the wall
    # so it might look like it went through the wall


    #draw to screen
    screen.fill((255,255,255))
    screen.blit(ball.image, (ball.x, ball.y))
    pygame.display.update()

    #slow down for next cycle - Aufgabe 2
    #ball.speed = ball.speed - (time_passed* (ball.speed))/5
    #if (ball.speed<1):
    #    ball.speed=0
    
